// BarcodeDlg.h : header file
//
#include "afxwin.h"
#if !defined(AFX_BARCODEDEMODLG_H__01A0CA2A_1668_4741_908A_F7B00BEAFEC7__INCLUDED_)
#define AFX_BARCODEDEMODLG_H__01A0CA2A_1668_4741_908A_F7B00BEAFEC7__INCLUDED_
#if _MSC_VER >=100
#pragma once
#endif

// CBarcodeDlg dialog
class CBarcodeDlg : public CDialog
{
// Construction
public:
	UINT m_nldx;
	CBarcodeDlg(CWnd* pParent = NULL);	// standard constructor
	BOOL is2DScanner;
// Dialog Data
	enum { IDD = IDD_BARCODE_DIALOG };
	CListCtrl	m_listBarcodeData;
	CButton m_btnStart;
	CButton m_btnStop;
	CButton m_btnClear;
	public:
	virtual BOOL DestroyWindow();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

// Implementation
protected:
	HICON m_hIcon;
	HANDLE m_thread;
	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedbtnstart();
	afx_msg void OnBnClickedbtnstop();
	afx_msg void OnBnClickedbtnclear();
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP() 
	afx_msg void OnTimer(UINT nIDEvent);
	
	
public:
	CComboBox cbxLightMode;
	CComboBox cbxLeaveLightOn;
	CButton m_chkRaw;
	CButton m_chkSound;
	CButton m_chkVibrator;
	afx_msg void OnCbnSelchangeLightMode();
	afx_msg void OnCbnSelchangeLeaveLightOn();
};
#endif
