// Kill.cpp :  Դϴ.
//

#include "stdafx.h"
#include "RFID.h"
#include "Kill.h"
#include "RFIDDef.h"
extern CString SelectedTagValue;
CString targetTagKill;
// CKill ȭ Դϴ.

IMPLEMENT_DYNAMIC(CKill, CDialog)

CKill::CKill(CWnd* pParent /*=NULL*/)
	: CDialog(CKill::IDD, pParent)
{

}

CKill::~CKill()
{
}

void CKill::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_KILL, m_editKillPassword);
	DDX_Control(pDX, IDC_TARGET_TAG, m_editTargetPattern);
	DDX_Control(pDX, IDC_BUTTON_KILL, m_btnKill);
	DDX_Control(pDX, IDC_EDIT_MESSAGE, m_nKillMessage);
}


BEGIN_MESSAGE_MAP(CKill, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_KILL, &CKill::OnBnClickedButtonKill)
END_MESSAGE_MAP()


// CKill ޽ óԴϴ.

BOOL CKill::OnInitDialog(){
	CDialog::OnInitDialog();
	if(RfidIsOpen() == FALSE) 
	{
		RfidPowerOff();
		AfxMessageBox(_T("open failed!"));
	}

	RETAILMSG(1, (TEXT("[APP, GetSelectedTag] ->> GetSelectedTag \t[ %s ] \r\n"), SelectedTagValue));
	int maxTargetLength = MAX_MASK_BYTES*2;
	targetTagKill = SelectedTagValue;
	if(targetTagKill.GetLength() > maxTargetLength)
		targetTagKill.SetString(targetTagKill,maxTargetLength);

	m_editTargetPattern.SetWindowTextW(targetTagKill);
	// If you want to operate synchronously, the operation time must be set to a value other than zero.
    // If set to 0, you may not be able to stop the operation.
	RfidSetOperationTime(3);

return TRUE;

}
void CKill::OnBnClickedButtonKill()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CString		sKillpwd;
	CString		sPattern;
	TCHAR		tszPattern[MAX_PATH] = _T(""),
				tszKillpwd[MAX_PATH] = _T("");
	RFID_RESULT			result;
	RFIDMASK_PARAMS		killMask;

	
	memset(&killMask, 0x00, sizeof(RFIDMASK_PARAMS));



	m_editKillPassword.GetWindowTextW(sKillpwd);
	if(!sKillpwd.Compare(_T("")) ==0){
		// kill password is a 4-byte data.
        // The 4-byte data that has already been written on the tag.
		if(sKillpwd.GetLength() !=8){
			AfxMessageBox(_T("Kill password is 4 bytes"));
			m_editKillPassword.GetFocus();
			return;
		}
		wsprintf(tszKillpwd, _T("%s"), sKillpwd);
	}

	m_editTargetPattern.GetWindowTextW(sPattern);
	m_editTargetPattern.GetWindowTextW(tszPattern, MAX_PATH);
	if(!sPattern.Compare(_T("")) ==0){
		// To kill only tags that you selected on the previous screen
		killMask.nOffSet =4;
		killMask.MemBank = RFID_MEM_BANK_EPC;
		killMask.szMaskPattern = tszPattern;
	}

	m_btnKill.EnableWindow(FALSE);

	// Warning : After completig kill operation, Tag can not be recovered.
    // The kill operation will be executed synchronously.
	result = RfidKillTag(TRUE,tszKillpwd, FALSE, &killMask);


	// if you call a function asynchronously, function will return immediately.
    // You need to check the execution results are received by the callback function.
    // But If you call a function synchronously, the return value is a function execution results.
	if(result == RFID_RESULT_SUCCESS){
		PlaySound( _T("\\Windows\\success.wav"), NULL, SND_ASYNC|SND_NOSTOP);
				
	}else{
		PlaySound( _T("\\Windows\\Fail.wav"), NULL, SND_ASYNC|SND_NOSTOP);
	}
	DisplayRfidResult(result);
	m_btnKill.EnableWindow(TRUE);


}

void CKill::DisplayRfidResult(RFID_RESULT result){
	TCHAR szResult[MAX_PATH];
	memset(szResult, 0x00, sizeof(szResult));
	
	switch(result)
	{
	case RFID_RESULT_SUCCESS:
		wsprintf(szResult, _T(" Success "));
		break;
		
	case RFID_RESULT_OUTOFMEMORY:
		wsprintf(szResult, _T(" Out Of Memory "));
		break;
		
	case RFID_RESULT_INVALID_ARGS:
		wsprintf(szResult, _T(" Invalid Args "));
		break;
		
	case RFID_RESULT_UNEXPECTED:
		wsprintf(szResult, _T(" UnExpected "));
		break;
		
	case RFID_RESULT_FAILURE:
		wsprintf(szResult, _T(" Failure "));
		break;
		
	case RFID_RESULT_ALREADY_OPENED:
		wsprintf(szResult, _T(" Alreaddy Opened "));
		break;

	case RFID_RESULT_INVALID_DEVICE:
		wsprintf(szResult, _T(" Invalid Device "));
		break;

	case RFID_RESULT_NOT_CONNECTED:
		wsprintf(szResult, _T(" Not Connected "));
		break;
		
	case RFID_RESULT_NOT_DETECT:
		wsprintf(szResult, _T(" Not Detect "));
		break;
		
	case RFID_RESULT_ACCESS_ERROR:
		wsprintf(szResult, _T(" Access Error "));
		break;
		
	case RFID_RESULT_NOT_OPENED:
		wsprintf(szResult, _T(" Not Open "));
		break;
		
	case RFID_RESULT_COMMAND_ERROR:
		wsprintf(szResult, _T(" Command Error "));
		break;
		
	case RFID_RESULT_LOW_BATTERY:
		wsprintf(szResult, _T(" Low Battery "));
		break;
		
	case RFID_RESULT_UNKNOWN:
		wsprintf(szResult, _T(" Unknown "));
		break;
		
	case RFID_RESULT_NOT_SUPPORTED:
		wsprintf(szResult, _T(" Not Supported "));
		break;
		
	case RFID_RESULT_STOPPED:
		wsprintf(szResult, _T(" Stopped "));
		break;
		
	case RFID_RESULT_POWER_OFF:
		wsprintf(szResult, _T(" Power Off "));
		break;
	}

	m_nKillMessage.SetWindowTextW(_T(""));
	m_nKillMessage.SetWindowTextW(szResult);

}