// Write.cpp :  Դϴ.
//

#include "stdafx.h"
#include "RFID.h"
#include "Write.h"
#include "RFIDDef.h"
extern CString SelectedTagValue;
CString targetTagWrite;
// CWrite ȭ Դϴ.

IMPLEMENT_DYNAMIC(CWrite, CDialog)

CWrite::CWrite(CWnd* pParent /*=NULL*/)
	: CDialog(CWrite::IDD, pParent)
{
	m_ReadWriteReoprtMode = MESSAGE_MODE_FUNCTION;
}

CWrite::~CWrite()
{
}

void CWrite::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, m_cbMemBank);
	DDX_Control(pDX, IDC_WORDPTR, m_cbWordPtr);
	DDX_Control(pDX, IDC_EDIT3, m_editAccesspwd);
	DDX_Control(pDX, IDC_EDIT4, m_editData);
	DDX_Control(pDX, IDC_EDIT2, m_editTarget);
	DDX_Control(pDX, IDC_EDIT_MESSAGE, m_stReply);
	DDX_Control(pDX, IDC_WRITE, m_btnWrite);
}


BEGIN_MESSAGE_MAP(CWrite, CDialog)

	ON_BN_CLICKED(IDC_WRITE, &CWrite::OnBnClickedWrite)
END_MESSAGE_MAP()


// CWrite ޽ óԴϴ.
BOOL CWrite::OnInitDialog(){
	CDialog::OnInitDialog();

	RFIDREPORTMODEPARAMS RfidParam;
	if(m_ReadWriteReoprtMode==1){
		RfidParam.nModeOff = RFID_REPORT_MODE_WAIT_DONE | RFID_REPORT_MODE_EXTENDED_INFORMATION;
	
	}else{
		RfidParam.nModeOn = RFID_REPORT_MODE_WAIT_DONE;
	}
	RfidSetReportMode(&RfidParam);
	

	RETAILMSG(1, (TEXT("[APP, GetSelectedTag] ->> GetSelectedTag \t[ %s ] \r\n"), SelectedTagValue));
	int maxTargetLength = MAX_MASK_BYTES*2;
	targetTagWrite = SelectedTagValue;
	if(targetTagWrite.GetLength() > maxTargetLength)
		targetTagWrite.SetString(targetTagWrite,maxTargetLength);

	m_editTarget.SetWindowTextW(targetTagWrite);


	m_cbMemBank.AddString(_T("EPC"));
	m_cbMemBank.AddString(_T("TID"));
	m_cbMemBank.AddString(_T("USER"));
	m_cbMemBank.AddString(_T("RESERVED"));
	m_cbMemBank.SetCurSel(0);
	
	CString strTemp=_T("");
	int nLoop =0;
	for(nLoop =0; nLoop <=20; nLoop++){
		strTemp.Format(_T("%d"),nLoop);
		m_cbWordPtr.AddString(strTemp);
	}
	m_cbWordPtr.SetCurSel(2);

	// If you want to operate synchronously, the operation time must be set to a value other than zero.
    // If set to 0, you may not be able to stop the operation.
	RfidSetOperationTime(3);
	return TRUE;
}
void CWrite::OnBnClickedWrite()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CString		sBtnStart;
	m_btnWrite.GetWindowTextW(sBtnStart);

	if(sBtnStart.Compare(_T("STOP")) !=0){
		UpdateWindow();
		m_btnWrite.SetWindowTextW(_T("STOP"));
	
		BlockWrite();
	}
	
	

}
BOOL CWrite::BlockWrite(){
	CString			sAccpwd;
	CString			sPattern;
	TCHAR			tszPattern[MAX_PATH] = _T("");
	TCHAR			tszAccpwd[MAX_PATH] = _T("");
	CString			sWriteData;
	TCHAR			tszWriteData[MAX_PATH] = _T("");
	TCHAR			tszAccEpc[MAX_PATH] = _T("");
	CString			sBtnStart;
	RFIDMEM_BANK	memBank;
	UINT			nWordPtr;
	RFIDMASK_PARAMS writeMask;
	RFID_RESULT		result;


	memset(&writeMask,0x00,sizeof(RFIDMASK_PARAMS));

	switch(this->m_cbMemBank.GetCurSel())
	{
		case 0:
			memBank = RFID_MEM_BANK_EPC;
			break;
		case 1:
			memBank = RFID_MEM_BANK_TID;
			break;
		case 2:
			memBank = RFID_MEM_BANK_USER;
			break;
		case 3:
			memBank = RFID_MEM_BANK_RESERVED;
			break;
	}
	// The memory area to be accessed is represented by WORD(2 bytes) unit.
    // If you increase the wordPtr 1, start address increases 2 bytes.
	nWordPtr =(UINT)this->m_cbWordPtr.GetCurSel();

	this->m_editAccesspwd.GetWindowTextW(sAccpwd);
	if(!sAccpwd.Compare(_T("")) ==0)
	{	// access password is a 4-byte data.
		if(sAccpwd.GetLength() != 8)
		{
			AfxMessageBox(_T("Access password is 4 bytes"));
			m_editAccesspwd.GetFocus();
			return FALSE;
		}
		wsprintf(tszAccpwd,_T("%s"),sAccpwd);
	}

	this->m_editData.GetWindowTextW(sWriteData);
	if(sWriteData.Compare(_T("")) ==0)
	{
		AfxMessageBox(_T("Write Data is NULL"));
		m_editData.GetFocus();
		m_btnWrite.SetWindowTextW(_T("Write"));

		return FALSE;
	}
	// All data on the RFID module for reading and writing must be a hexadecimal string.
    // For example, if you want to write the 1234, you must input "31323334".
    // In order to write "ABCD", you must enter "41424344".
	wsprintf(tszWriteData,_T("%s"),sWriteData);

	this->m_editTarget.GetWindowTextW(sPattern);
	if(!sPattern.Compare(_T(""))==0){
		// To write only tags that you selected on the previous screen
		writeMask.nOffSet = 4;
		writeMask.MemBank = RFID_MEM_BANK_EPC;
		wsprintf(tszPattern,_T("%s"),sPattern);
		writeMask.szMaskPattern = tszPattern;
	}

	// The write operation will be executed synchronously.
	result = RfidWriteMemBank(TRUE,memBank,nWordPtr,tszWriteData,FALSE,tszAccpwd,&writeMask);


	// if you call a function asynchronously, function will return immediately.
    // You need to check the execution results are received by the callback function.
    // But If you call a function synchronously, the return value is a function execution results.
	if(result == RFID_RESULT_SUCCESS)
	{
		PlaySound( _T("\\Windows\\success.wav"), NULL, SND_ASYNC|SND_NOSTOP);
	}else
	{
		PlaySound( _T("\\Windows\\Fail.wav"), NULL, SND_ASYNC|SND_NOSTOP);
	}
	RfidGetAccessedEpc(tszAccEpc);
	DisplayRfidResult(result);
	m_btnWrite.GetWindowTextW(sBtnStart);
	if(!sBtnStart.Compare(_T("Write"))==0){
		m_btnWrite.SetWindowTextW(_T("Write"));
	}
	return TRUE;
}

void CWrite::DisplayRfidResult(RFID_RESULT result){
	TCHAR szResult[MAX_PATH];
	memset(szResult, 0x00, sizeof(szResult));
	
	switch(result)
	{
	case RFID_RESULT_SUCCESS:
		wsprintf(szResult, _T(" Success "));
		break;
		
	case RFID_RESULT_OUTOFMEMORY:
		wsprintf(szResult, _T(" Out Of Memory "));
		break;
		
	case RFID_RESULT_INVALID_ARGS:
		wsprintf(szResult, _T(" Invalid Args "));
		break;
		
	case RFID_RESULT_UNEXPECTED:
		wsprintf(szResult, _T(" UnExpected "));
		break;
		
	case RFID_RESULT_FAILURE:
		wsprintf(szResult, _T(" Failure "));
		break;
		
	case RFID_RESULT_ALREADY_OPENED:
		wsprintf(szResult, _T(" Alreaddy Opened "));
		break;

	case RFID_RESULT_INVALID_DEVICE:
		wsprintf(szResult, _T(" Invalid Device "));
		break;

	case RFID_RESULT_NOT_CONNECTED:
		wsprintf(szResult, _T(" Not Connected "));
		break;
		
	case RFID_RESULT_NOT_DETECT:
		wsprintf(szResult, _T(" Not Detect "));
		break;
		
	case RFID_RESULT_ACCESS_ERROR:
		wsprintf(szResult, _T(" Access Error "));
		break;
		
	case RFID_RESULT_NOT_OPENED:
		wsprintf(szResult, _T(" Not Open "));
		break;
		
	case RFID_RESULT_COMMAND_ERROR:
		wsprintf(szResult, _T(" Command Error "));
		break;
		
	case RFID_RESULT_LOW_BATTERY:
		wsprintf(szResult, _T(" Low Battery "));
		break;
		
	case RFID_RESULT_UNKNOWN:
		wsprintf(szResult, _T(" Unknown "));
		break;
		
	case RFID_RESULT_NOT_SUPPORTED:
		wsprintf(szResult, _T(" Not Supported "));
		break;
		
	case RFID_RESULT_STOPPED:
		wsprintf(szResult, _T(" Stopped "));
		break;
		
	case RFID_RESULT_POWER_OFF:
		wsprintf(szResult, _T(" Power Off "));
		break;
	}


	this->m_stReply.SetWindowTextW(_T(""));
	this->m_stReply.SetWindowTextW(szResult);
}