﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Modem
{
    public partial class Form2 : Form
    {
        public Form2(string CodeType)
        {
            InitializeComponent();
            this.Text = "PIN Authorization";
            switch (CodeType)
            {
                case "SIM_PIN":
                    label2.Visible = false;
                    tbxNewPin.Visible = false;
                    break;
                case "SIM_PUK":
                    label1.Text = "Enter PUK Number";
                    label2.Visible = true;
                    tbxNewPin.Visible = true;
                    break;
            }
        }

        public string Code
        {
            get
            {
                return this.tbxOldPin.Text.Trim();
            }
        }

        public string NewCode
        {
            get
            {
                return this.tbxNewPin.Text.Trim();
            }
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
        }
    }
}