// RFIDDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "RFIDDef.h"
#include "afxwin.h"

#include<iostream>
#include<queue>


using namespace std;
// CRFIDDlg dialog
class CRFIDDlg : public CDialog
{
// Construction
public:
	
	CString GetSelectedTag();
	void DisplayRfidResult(RFID_RESULT result);
	void SetErrorMessage(LPWSTR szBuffer, RFID_RESULT result);
	CRFIDDlg(CWnd* pParent = NULL);	// standard constructor
	BOOL m_isRunning;
	UINT m_nMaxPower;
	BOOL isDoTel; 
	BOOL exitThread;
	static UINT threadDequeueProc(LPVOID _mothod);
	CWinThread *threadDequeue;
	HANDLE m_hEvent;
	void setButtons(BOOL enable);
	HWND hMain;
// Dialog Data
	enum { IDD = IDD_RFID_DIALOG };
	queue<CString> qTags;
	

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL PreTranslateMessage(MSG* pMsg);
// Implementation
protected:
	HICON m_hIcon;
	// Generated message map functions
	virtual BOOL OnInitDialog();
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
#endif
	DECLARE_MESSAGE_MAP()
protected:
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
	afx_msg void OnClose();
	virtual void OnOK();
	virtual void OnCancel();
	
public:
	CListCtrl m_listInventory;
	afx_msg void OnBnClickedInventory();
	CButton m_btnInventory;


	afx_msg void OnBnClickedClear();
	afx_msg void OnBnClickedRead();
	afx_msg void OnBnClickedWrite();
	afx_msg void OnBnClickedLock();
	afx_msg void OnBnClickedButton3();
	CComboBox m_nSession;
	CComboBox m_nTarget;
	CComboBox m_cbPower;
	CComboBox m_cbQvalue;
	afx_msg void OnCbnSelchangeComboSession();
	afx_msg void OnCbnSelchangeComboTarget();
	afx_msg void OnCbnSelchangeComboPower();
	afx_msg void OnCbnSelchangeCombo4();
	CButton m_btnClear;
	CButton m_btnWrite;
	CButton m_btnRead;
	CButton m_btnLock;
	CButton m_btnKill;
protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
};
