// Read.cpp :  Դϴ.
//

#include "stdafx.h"
#include "RFID.h"
#include "Read.h"
#include "RFIDDef.h"

extern CString SelectedTagValue;
CString targetTag;
// Read ȭ Դϴ.

IMPLEMENT_DYNAMIC(Read, CDialog)

Read::Read(CWnd* pParent /*=NULL*/)
	: CDialog(Read::IDD, pParent)
{
	m_ReadWriteReoprtMode = MESSAGE_MODE_FUNCTION;
}

Read::~Read()
{
}

void Read::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_MEMBANK, m_cbMemBank);
	DDX_Control(pDX, IDC_WORDPTR, m_cbWordPtr);
	DDX_Control(pDX, IDC_READ, m_btnRead);
	DDX_Control(pDX, IDC_EDIT_ACCPWD, m_editAccesspwd);
	DDX_Control(pDX, IDC_WORDCNT, m_nWordCnt);
	DDX_Control(pDX, IDC_EDIT_TARGET, m_editTarget);
	DDX_Control(pDX, IDC_EDIT1, m_nReadCodeData);

	DDX_Control(pDX, IDC_COMBO4, m_cbPreDefined);
}


BEGIN_MESSAGE_MAP(Read, CDialog)

	ON_BN_CLICKED(IDC_READ, &Read::OnBnClickedRead)
	ON_CBN_SELCHANGE(IDC_COMBO4, &Read::OnCbnSelchangeCombo4)
END_MESSAGE_MAP()


// Read ޽ óԴϴ.

BOOL Read::OnInitDialog(){
	CDialog::OnInitDialog();
	
	if(RfidIsOpen() == FALSE) 
	{
		RfidPowerOff();
		AfxMessageBox(_T("open failed!"));
	}
	


	CString strTemp=_T("");
	int nLoop =0;
	RETAILMSG(1, (TEXT("[APP, GetSelectedTag] ->> GetSelectedTag \t[ %s ] \r\n"), SelectedTagValue));
	int maxTargetLength = MAX_MASK_BYTES*2;
	targetTag = SelectedTagValue;
	if(targetTag.GetLength() > maxTargetLength)
		targetTag.SetString(targetTag,maxTargetLength);

	m_editTarget.SetWindowTextW(targetTag);
	
	m_cbMemBank.AddString(_T("EPC"));
	m_cbMemBank.AddString(_T("TID"));
	m_cbMemBank.AddString(_T("USER"));
	m_cbMemBank.AddString(_T("RESERVED"));
	m_cbMemBank.SetCurSel(0);

	for(nLoop =0; nLoop <=20; nLoop++){
		strTemp.Format(_T("%d"),nLoop);
		m_cbWordPtr.AddString(strTemp);
	
	}
	m_cbWordPtr.SetCurSel(2);

	for(nLoop =0; nLoop <=20; nLoop++){
		strTemp.Format(_T("%d"),nLoop);
		m_nWordCnt.AddString(strTemp);
	
	}
	m_nWordCnt.SetCurSel(4);
	
	m_cbPreDefined.AddString(_T("User defined"));
	m_cbPreDefined.AddString(_T("Access password"));
	m_cbPreDefined.AddString(_T("Kill password"));
	m_cbPreDefined.AddString(_T("Protocol-control word"));
	m_cbPreDefined.SetCurSel(0);


	// If you want to operate synchronously, the operation time must be set to a value other than zero.
    // If set to 0, you may not be able to stop the operation.
	RfidSetOperationTime(3);
	return TRUE;
}
void Read::OnBnClickedRead()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	CString		sBtnStart;
	m_btnRead.GetWindowTextW(sBtnStart);

	if(sBtnStart.Compare(_T("STOP")) !=0){
		UpdateWindow();
		m_btnRead.SetWindowTextW(_T("STOP"));
	
		BlockRead();
	}
} 
BOOL Read::BlockRead(){


	CString		sAccpwd;
	CString		sPattern;
	TCHAR		tszPattern[MAX_PATH] = _T(""),
				tszAccpwd[MAX_PATH] = _T("");

	CString		sReadData;
	TCHAR		tszReadData[MAX_PATH] = _T("");
	//LPWSTR		szErr;
	CString				sBtnStart;
	RFIDMEM_BANK		MemBank;
	UINT				nWordPtr;
	UINT				nWordCount;
	LPWSTR				szMemBankData = _T("");


	RFIDMASK_PARAMS readMask;
	RFID_RESULT result;

	memset(&readMask,0x00, sizeof(RFIDMASK_PARAMS));


	this->m_editAccesspwd.GetWindowTextW(sAccpwd);
	if(!sAccpwd.Compare(_T("")) ==0){
		// access password is a 4-byte data.
		if(sAccpwd.GetLength() != 8)
		{
			AfxMessageBox(_T("Access password is 4 bytes"));
			m_editAccesspwd.GetFocus();
			return FALSE;
		}
		wsprintf(tszAccpwd, _T("%s"), sAccpwd);
	}

	switch(this->m_cbMemBank.GetCurSel()){
		case 0:
			MemBank = RFID_MEM_BANK_EPC;
			break;
		case 1:
			MemBank = RFID_MEM_BANK_TID;
			break;
		case 2:
			MemBank = RFID_MEM_BANK_USER;
			break;
		case 3:
			MemBank = RFID_MEM_BANK_RESERVED;
			break;
	}

	// The memory area to be accessed is represented by WORD(2 bytes) unit.
    // If you increase the wordPtr 1, start address increases 2 bytes.
    // If you increase the wordCnt 1, the amount of memory increases 2byte.
	nWordPtr= (UINT)this->m_cbWordPtr.GetCurSel();
	nWordCount = (UINT)this->m_nWordCnt.GetCurSel();


	this->m_editTarget.GetWindowTextW(sPattern);
	if(!sPattern.Compare(_T("")) ==0){
		// To read only tags that you selected on the previous screen
		readMask.nOffSet =4;
		readMask.MemBank = RFID_MEM_BANK_EPC;
		wsprintf(tszPattern, _T("%s"),sPattern);
		readMask.szMaskPattern = tszPattern;
	
	}

			// The read operation will be executed synchronously.
			result = RfidReadMemBank(TRUE,MemBank,nWordPtr,nWordCount,FALSE,tszAccpwd,&readMask,tszReadData);

			// if you call a function asynchronously, function will return immediately.
            // You need to check the execution results are received by the callback function.
            // But If you call a function synchronously, the return value is a function execution results.
			if(result == RFID_RESULT_SUCCESS){
				PlaySound( _T("\\Windows\\success.wav"), NULL, SND_ASYNC|SND_NOSTOP);
				// The read operation was executed successfully.
                // Cut only the data
				m_nReadCodeData.SetWindowTextW(tszReadData);
			}else{
				// The read operation has failed.
				PlaySound( _T("\\Windows\\Fail.wav"), NULL, SND_ASYNC|SND_NOSTOP);
				DisplayRfidResult(result);
			}

			m_btnRead.GetWindowTextW(sBtnStart);
			if(sBtnStart.Compare(_T("Read")) !=0){
				m_btnRead.SetWindowTextW(_T("Read"));
			}

			return TRUE;
}

void Read::DisplayRfidResult(RFID_RESULT result){
	TCHAR szResult[MAX_PATH];
	memset(szResult, 0x00, sizeof(szResult));
	
	switch(result)
	{
	case RFID_RESULT_SUCCESS:
		wsprintf(szResult, _T(" Success "));
		break;
		
	case RFID_RESULT_OUTOFMEMORY:
		wsprintf(szResult, _T(" Out Of Memory "));
		break;
		
	case RFID_RESULT_INVALID_ARGS:
		wsprintf(szResult, _T(" Invalid Args "));
		break;
		
	case RFID_RESULT_UNEXPECTED:
		wsprintf(szResult, _T(" UnExpected "));
		break;
		
	case RFID_RESULT_FAILURE:
		wsprintf(szResult, _T(" Failure "));
		break;
		
	case RFID_RESULT_ALREADY_OPENED:
		wsprintf(szResult, _T(" Alreaddy Opened "));
		break;

	case RFID_RESULT_INVALID_DEVICE:
		wsprintf(szResult, _T(" Invalid Device "));
		break;

	case RFID_RESULT_NOT_CONNECTED:
		wsprintf(szResult, _T(" Not Connected "));
		break;
		
	case RFID_RESULT_NOT_DETECT:
		wsprintf(szResult, _T(" Not Detect "));
		break;
		
	case RFID_RESULT_ACCESS_ERROR:
		wsprintf(szResult, _T(" Access Error "));
		break;
		
	case RFID_RESULT_NOT_OPENED:
		wsprintf(szResult, _T(" Not Open "));
		break;
		
	case RFID_RESULT_COMMAND_ERROR:
		wsprintf(szResult, _T(" Command Error "));
		break;
		
	case RFID_RESULT_LOW_BATTERY:
		wsprintf(szResult, _T(" Low Battery "));
		break;
		
	case RFID_RESULT_UNKNOWN:
		wsprintf(szResult, _T(" Unknown "));
		break;
		
	case RFID_RESULT_NOT_SUPPORTED:
		wsprintf(szResult, _T(" Not Supported "));
		break;
		
	case RFID_RESULT_STOPPED:
		wsprintf(szResult, _T(" Stopped "));
		break;
		
	case RFID_RESULT_POWER_OFF:
		wsprintf(szResult, _T(" Power Off "));
		break;
	}

	this->m_nReadCodeData.SetWindowTextW(szResult);

}
void Read::OnCbnSelchangeCombo4()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

	int idx = m_cbPreDefined.GetCurSel();
	switch(idx){
		case 0: // user defined
			m_cbMemBank.SetCurSel(0);
			m_cbWordPtr.SetCurSel(2);
			m_nWordCnt.SetCurSel(4);
			break;
		case 1: // access password
			m_cbMemBank.SetCurSel(3); // RESERVED bank
			m_cbWordPtr.SetCurSel(2); // WordPtr = 2
			m_nWordCnt.SetCurSel(2);  // WordCnt = 2
			break;
		case 2: // kill password
			m_cbMemBank.SetCurSel(3); // RESERVED bank
			m_cbWordPtr.SetCurSel(0); // WordPtr = 0
			m_nWordCnt.SetCurSel(2);  // WordCnt = 2
			break;
		case 3: // protocol-control word
			m_cbMemBank.SetCurSel(0); // EPC bank
			m_cbWordPtr.SetCurSel(1); // WordPtr = 1
			m_nWordCnt.SetCurSel(1);  // WordCnt = 1
			break;
	
	}
	m_cbMemBank.EnableWindow(idx==0?TRUE:FALSE);
	m_cbWordPtr.EnableWindow(idx==0?TRUE:FALSE);
	m_nWordCnt.EnableWindow(idx==0?TRUE:FALSE);
}
