// SysSvcDlg.h : header file
//

#pragma once

#include "SysSvcDef.h"
#include "afxwin.h"
#include "afxcmn.h"
#define WIRELESS_DEVICE_WLAN 0
#define WIRELESS_DEVICE_BLUETOOTH 2
// CSysSvcDlg dialog
class CSysSvcDlg : public CDialog
{
// Construction
public:
	CSysSvcDlg(CWnd* pParent = NULL);	// standard constructor
	
// Dialog Data
	enum { IDD = IDD_SYSSVC_DIALOG };

	public:
	virtual BOOL DestroyWindow();
	void ReadPowerAndBacklightStatus(char mode);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	SYSSVC_RESULT result;
	HW_OPTIONS hwOptions;
	KBD_STATUS keypadStatus;

// Implementation
protected:
	HICON m_hIcon;
	
	
	// Generated message map functions
	virtual BOOL OnInitDialog();
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
#endif
	DECLARE_MESSAGE_MAP()
public:
	UINT m_nBrightnessValue;
	CStatic tbxDeviceId;
	CButton chkWiFi;
	CButton chkBluetooth;
	CComboBox cbxMode;
	CComboBox cbxKeypadStatus;
	//CEdit nudTurnOffDevice;
	//CEdit nudTurnOffBacklight;
	//CEdit nudBacklightBrightness;
	CButton cbkFlashLight;
	afx_msg void OnBnClickedWifi();
	afx_msg void OnBnClickedBluetooth();
	afx_msg void OnBnClickedCheck3();
	CButton chkVibrator;
	afx_msg void OnBnClickedVibrator();
	afx_msg void OnBnClickedFlashlight();
	afx_msg void OnCbnSelchangeMode();
	afx_msg void OnCbnSelchangeKeypadstatus();
	afx_msg void OnDeltaposDevice(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedButton1();
	afx_msg void OnBnClickedButton2();
	afx_msg void OnBnClickedButton3();
	int m_nTurnOffDevice;
	//afx_msg void OnDeltaposSpin1(NMHDR *pNMHDR, LRESULT *pResult);
	CEdit m_tbxTurnOffDevice;

	//afx_msg void OnDeltaposBacklight(NMHDR *pNMHDR, LRESULT *pResult);
	int m_nTimeOutValue;
	//afx_msg void OnDeltaposSpinBacklightbrightness(NMHDR *pNMHDR, LRESULT *pResult);
	int m_nBrightValue;
	CEdit m_ntbxTimeOutValue;
	CEdit m_tbxBrightValue;
	CSpinButtonCtrl m_SPIN_SusPendValue;
	CSpinButtonCtrl m_SPIN_TimeOutValue;
	CSpinButtonCtrl m_SPIN_BrightnessValue;
	afx_msg void OnBnClickedButton4();
	afx_msg void OnBnClickedButton5();
	afx_msg void OnBnClickedButton6();
};
