#ifndef __CSYSSVC__API__H__
#define __CSYSSVC__API__H__
//#include <ioctl_cfg.h>
// 2012.03.12 yjcho #include "../../../Common/Inc_WM/Global.h"
//#include <Global.h>

// ?????????
//#include "../../../Common/Inc_WINCE/ioctl_cfg.h"
//#include "../../../Common/Inc_WINCE/Global.h"


#define CSysSvcApi_API extern "C" __declspec(dllexport)

#define MODE_BAT	0
#define MODE_AC		1
#define MODE_KEYLAMP_OFFTIME_START	0
#define MODE_KEYLAMP_OFFTIME_END	1

#define LB_PAGE_SIZE	2048		//Don't Change

//typedef enum _FLASHIOCTL{
//	IOCTL_INIT = 0,
//	IOCTL_READ,
//	IOCTL_WRITE,
//	IOCTL_COMPLETED
//}FLASHIOCTL;
//
//typedef struct _FLASHRWCTL{
//	FLASHIOCTL	FlsIoctl;
//	DWORD	dwBlkNum;
//	DWORD	dwSectorNum;
//	UCHAR		ucBuffer[LB_PAGE_SIZE];
//}FLASHRWCTL;

typedef enum _FLASH_IO_CODE{
	IO_CODE_INIT = 0,
	IO_CODE_READ,
	IO_CODE_WRITE,
	IO_COMPLETED
}FLASH_IO_CODE;

typedef struct _FLASH_RW_INFOS
{
	FLASH_IO_CODE	FlsIoctl;
	DWORD	dwBlkNum;
	DWORD	dwSectorNum;
	UCHAR		ucBuffer[LB_PAGE_SIZE]; 
}FLASH_RW_INFOS;

typedef enum{
	AUDIOCODECCTRL_READ = 0,
	AUDIOCODECCTRL_WRITE,
	AUDIOCODECCTRL_SET
}AUDIOCODECCTRL;

typedef enum{
	CODEC_MIC_VOLUME = 0,
	CODEC_SPEAKER_VOLUME
}AUDIOCODECVOLUME;

typedef struct{
	AUDIOCODECCTRL AudioCodecCtrl;
	AUDIOCODECVOLUME AudioCodecVolume;
	USHORT VolumeLevel;
}AUDIOCODECVOLCTL;

typedef enum
{
	IPM_OP_104MHZ = 0,
	IPM_OP_208MHZ,
	IPM_OP_416MHZ,
	IPM_OP_624MHZ,
	IPM_OP_806MHZ,
	IPM_OP_AUTO

} IPM_PRODUCT_OP;

typedef struct
{
	BOOL bEnterSleep;
	BOOL bBatteryDetect;
}SLEEPWAKEUP_PARAMS;

typedef enum
{
	KBD_STATUS_UPPER_CASE = 40001,
	KBD_STATUS_LOWER_CASE,
	KBD_STATUS_NUMERIC
}KBD_STATUS;

#pragma pack(push, 1)
#define VERSION_LEN			48   //BOOT / OS Version Length
typedef struct {
	unsigned char ProcessID[VERSION_LEN];
	unsigned char HWVer[VERSION_LEN];
	unsigned char BOOTVer[VERSION_LEN];
	unsigned char OSVer[VERSION_LEN];
	unsigned char BuildDate[VERSION_LEN];
	unsigned char BuildTime[VERSION_LEN];
	unsigned char AKUVer[VERSION_LEN];
}VERSION_INFORMATIONS;

typedef struct _UPDATEINFORMATIONS{
	DWORD	dwMOBMStartBlk;
	DWORD	dwBOOTStartBlk;
	DWORD	dwLOGOStartBlk;
	DWORD	dwLOGOBlkSize;
	DWORD	dwOSStartBlk;
	WORD		nBytesPerPage;
	char			nSectorsPerPage;
	WORD		nPagesPerBlock;
}UPDATEINFORMATIONS;

#pragma pack(pop)

#define WM_SLEEP_WAKEUP_NOTIFY	WM_USER + 1805
#define WM_BATT_DETECT_NOTIFY	WM_USER + 1807
#define WM_KEYEVENT_NOTIFY		WM_USER + 1809

#define HW_TYPE_UHF_NONE				0x30
#define HW_TYPE_UHF_H1000				0x31
#define HW_TYPE_UHF_I2000				0x32
#define HW_TYPE_UHF_I900				0x33

#define HW_TYPE_MODEM_NONE				0
#define HW_TYPE_MODEM_AM200				1
#define HW_TYPE_MODEM_AME200			2
#define HW_TYPE_MODEM_UC864				3
#define HW_TYPE_MODEM_HC25				4
#define HW_TYPE_MODEM_HC28				5
#define HW_TYPE_MODEM_PH8				6
#define HW_TYPE_MODEM_MC55I				7
#define HW_TYPE_MODEM_HUAWEI			8
#define HW_TYPE_MODEM_AME300			9
#define HW_TYPE_MODEM_BPLM210			10
#define HW_TYPE_MODEM_TM401				11

#define HW_TYPE_BARCODE_NONE			0
#define HW_TYPE_BARCODE_1D				1
#define HW_TYPE_BARCODE_2DHWD			2
#define HW_TYPE_BARCODE_2DSWD_H			3
#define HW_TYPE_BARCODE_2DSWD_M			4
#define HW_TYPE_BARCODE_1D_HHP			5
#define HW_TYPE_BARCODE_1D_HHP_EX25		6
#define HW_TYPE_BARCODE_1D_SE965		7

#define HW_TYPE_HF_NONE					0
#define HW_TYPE_HF_ESB					1

#define HW_TYPE_CAM_NONE				0
#define HW_TYPE_CAM_OV3640				1
#define HW_TYPE_CAM_MT9T112				2

#define HW_TYPE_WLAN_NONE				0
#define HW_TYPE_WLAN_MCF10G				1
#define HW_TYPE_WLAN_MSD10G				2
#define HW_TYPE_WLAN_MSD30AG			3
#define HW_TYPE_WLAN_MSD45N				4

#define HW_TYPE_BLUETOOTH_NONE			0
#define HW_TYPE_BLUETOOTH_HBM2X1M		1
#define HW_TYPE_BLUETOOTH_MD6RF			2
#define HW_TYPE_BLUETOOTH_F1C26			3
#define HW_TYPE_BLUETOOTH_F1C81			4

#define HW_TYPE_GPS_NONE				0
#define HW_TYPE_GPS_UBLUX				1
#define HW_TYPE_GPS_SIRF3				2
#define HW_TYPE_GPS_IT530M				3
#define HW_TYPE_GPS_UBLOX_MAX7			4
#define HW_TYPE_GPS_SIRF4				5

#define HW_TYPE_SMARTCARD_NONE			0
#define HW_TYPE_SMARTCARD_73S12XXF		1
#define HW_TYPE_SMARTCARD_EICM1000		2

#define HW_TYPE_PRINTER_NONE			0
#define HW_TYPE_PRINTER_LTPD245			1

#define HW_TYPE_MSR_NONE				0
#define HW_TYPE_MSR_MCR_3006			1

#define HW_TYPE_FINGER_PRINT_NONE		0
#define HW_TYPE_FINGER_PRINT_TFM_100AI	1
#define HW_TYPE_FINGER_PRINT_HFF_101	2

typedef struct {
	BYTE ModemType;
	BYTE BarcodeType;
	BYTE HFType;
	BYTE UHFType;
	BYTE CamType;
	BYTE WLANType;
	BYTE BluetoothType;
	BYTE GPSType;
	BYTE SmartCardType;
	BYTE PrinterType;
	BYTE MSRType;
	BYTE FingerPrintType;
}HW_OPTIONS;

typedef enum
{
	SYSSVC_RESULT_SUCCESS			= 0,
	SYSSVC_RESULT_INVALID_ARGS,
	SYSSVC_RESULT_OUTOFMEMORY,
	SYSSVC_RESULT_UNSUPPORTED,
	SYSSVC_RESULT_FAILURE,
	SYSSVC_RESULT_INVALID_DEVICE
}SYSSVC_RESULT;


CSysSvcApi_API SYSSVC_RESULT AllocSysSvc();
CSysSvcApi_API SYSSVC_RESULT DeallocSysSvc();

// Backlight
CSysSvcApi_API SYSSVC_RESULT BacklightWriteTimeoutValue(char Mode, WORD nSeconds);
CSysSvcApi_API SYSSVC_RESULT BacklightReadTimeoutValue(char Mode, WORD * pnSeconds);
CSysSvcApi_API SYSSVC_RESULT BacklightSetBrightness(WORD nBrightness);
CSysSvcApi_API SYSSVC_RESULT BacklightGetBrightness(WORD * npBrightness);
CSysSvcApi_API SYSSVC_RESULT BacklightReadBrightness(char Mode, WORD * pnBrightness);
CSysSvcApi_API SYSSVC_RESULT BacklightWriteBrightness(char Mode, WORD nBrightness);

// Key Lamp
CSysSvcApi_API SYSSVC_RESULT KeyLampTurnOn();
CSysSvcApi_API SYSSVC_RESULT KeyLampTurnOff();
CSysSvcApi_API SYSSVC_RESULT KeyLampWriteTimeoutValue(WORD nSeconds);
CSysSvcApi_API SYSSVC_RESULT KeyLampReadTimeoutValue(WORD * pnSeconds);
CSysSvcApi_API SYSSVC_RESULT KeyLampWriteOffTimeValue(WORD nHoursFrom, WORD nMinutesFrom, WORD nHoursTo, WORD nMinutesTo);
CSysSvcApi_API SYSSVC_RESULT KeyLampReadOffTimeValue(WORD * pnHoursFrom, WORD * pnMinutesFrom, WORD * pnHoursTo, WORD * pnMinutesTo);
CSysSvcApi_API SYSSVC_RESULT KeyLampWriteOffTimeEnable(BOOL bEnable);
CSysSvcApi_API SYSSVC_RESULT KeyLampReadOffTimeEnable(BOOL * pbEnable);

// LCD
CSysSvcApi_API SYSSVC_RESULT LcdTurnOn();
CSysSvcApi_API SYSSVC_RESULT LcdTurnOff();
CSysSvcApi_API SYSSVC_RESULT LcdWriteTimeoutEnable(BOOL bEnable);
CSysSvcApi_API SYSSVC_RESULT LcdReadTimeoutEnable(BOOL pbEnable);
CSysSvcApi_API SYSSVC_RESULT LcdWriteTimeoutValue(WORD nSeconds);
CSysSvcApi_API SYSSVC_RESULT LcdReadTimeoutValue(WORD pnSeconds);

// Suspend 
CSysSvcApi_API SYSSVC_RESULT SuspendReadTimeoutValue(char Mode, WORD * pnSeconds);
CSysSvcApi_API SYSSVC_RESULT SuspendWriteTimeoutValue(char Mode, WORD nSeconds);

// Get Software Version
CSysSvcApi_API SYSSVC_RESULT GetSoftwareVersion(VERSION_INFORMATIONS* pVersionInfos);

// WLAN Pwr ON/OFF
CSysSvcApi_API SYSSVC_RESULT SetWlanPowerEnable(BOOL bEnable);
CSysSvcApi_API SYSSVC_RESULT GetWlanPowerStatus(BOOL* pbEnable);

// Flash Control
CSysSvcApi_API SYSSVC_RESULT UpdateInitFlash(UPDATEINFORMATIONS * pUpdateInfo);
CSysSvcApi_API SYSSVC_RESULT UpdateReadFlash(FLASH_RW_INFOS * pFlashCtrl);
CSysSvcApi_API SYSSVC_RESULT UpdateWriteFlash(FLASH_RW_INFOS FlashCtrl);
CSysSvcApi_API SYSSVC_RESULT UpdateCompleted(FLASH_RW_INFOS FlashCtrl);

// Sound Codec Control
CSysSvcApi_API SYSSVC_RESULT AudioCodecControl(AUDIOCODECVOLCTL AudioCodecVolCtrl);
CSysSvcApi_API SYSSVC_RESULT ReadAudioCodecGainLevel(AUDIOCODECVOLUME Codec, USHORT* pGainLevel);
CSysSvcApi_API SYSSVC_RESULT WriteAudioCodecGainLevel(AUDIOCODECVOLUME Codec, USHORT GainLevel); 
CSysSvcApi_API SYSSVC_RESULT SetAudioCodecGainLevel(AUDIOCODECVOLUME Codec, USHORT GainLevel); 

// Set, Reset Sleep/WakeUp Notification
CSysSvcApi_API SYSSVC_RESULT SleepWakeupNotificationSet(HWND hWnd);
CSysSvcApi_API SYSSVC_RESULT SleepWakeupNotificationReset(HWND hWnd);

// Vibrator Control
CSysSvcApi_API SYSSVC_RESULT SetVibratorEnable(BOOL bEnable);

// CPU Clock Control
CSysSvcApi_API SYSSVC_RESULT SetCpuClock(IPM_PRODUCT_OP Clock);
CSysSvcApi_API SYSSVC_RESULT GetCpuClock(IPM_PRODUCT_OP* pClock);

// Backlight Off(while modem use)
CSysSvcApi_API SYSSVC_RESULT SetModemScreenOffTime(WORD nSeconds);
CSysSvcApi_API SYSSVC_RESULT GetModemScreenOffTime(WORD* pnSeconds);

// Read DeviceID, UUID
CSysSvcApi_API SYSSVC_RESULT ReadDeviceId(UCHAR * pDeviceId);
CSysSvcApi_API SYSSVC_RESULT ReadUuid(UCHAR * pUuid);

// Enter Suspend State
CSysSvcApi_API SYSSVC_RESULT EnterSuspendState();

// KBD Status
CSysSvcApi_API SYSSVC_RESULT SetKBDStatus(KBD_STATUS KbdStatus);
CSysSvcApi_API SYSSVC_RESULT GetKBDStatus(KBD_STATUS* pkbdStatus);

// Soft Reset 
CSysSvcApi_API SYSSVC_RESULT SoftReset();

// FlashLight Control
CSysSvcApi_API SYSSVC_RESULT EnableFlashLight(BOOL Enable);

// Set, Reset keybd event Notification
typedef void (CALLBACK* KEYEVENTCALLBACK)(DWORD keyCode, DWORD keyState);
CSysSvcApi_API SYSSVC_RESULT KeyEventNotificationSet(KEYEVENTCALLBACK pCallback, HWND hWnd);
CSysSvcApi_API SYSSVC_RESULT KeyEventNotificationReset();

// Wireless devices power state
#define WD_TYPE_WLAN				0
#define WD_TYPE_PHONE				1
#define WD_TYPE_BLUETOOTH			2

#define WD_PWR_STATE_OFF			0
#define WD_PWR_STATE_ON				1
#define WD_PWR_STATE_DISCOVERABLE	2

CSysSvcApi_API SYSSVC_RESULT GetWirelessDevicesPowerState(int nDevice, int * pnState);
CSysSvcApi_API SYSSVC_RESULT SetWirelessDevicesPowerState(int nDevice, int nState);

CSysSvcApi_API SYSSVC_RESULT SetPWR_EN(BOOL bEnable);
CSysSvcApi_API SYSSVC_RESULT SetFW_EN(BOOL bEnable);
CSysSvcApi_API SYSSVC_RESULT SetRF_5V(BOOL bEnable);

// Get Hardware options
CSysSvcApi_API SYSSVC_RESULT GetHardwareOptions(HW_OPTIONS* pOptions);

#endif

















