﻿Imports NRfidApi
Imports NSysSvcApi
Imports RFID_VB._Native
Imports System.Collections

Public Class frmKill
    Public targetTag As String = String.Empty
    Dim result As RFID_RESULT = RFID_RESULT.RFID_RESULT_FAILURE
    Public Sub New(ByVal _epc As String)

        ' 이 호출은 Windows Form 디자이너에 필요합니다.
        InitializeComponent()

        ' InitializeComponent() 호출 뒤에 초기화 코드를 추가하십시오.

        Me.Text = "Kill Example"
        Me.MinimizeBox = False
        Me.MaximizeBox = False

        If (Utils.IsWinCE) Then
            Me.Menu = Nothing
            panel1.Location = New Point(0, 0)
        End If

        Me.targetTag = _epc

        Dim maxTargetLength As Integer = RfidApi.MAX_MASK_BYTES * 2
        If (Me.targetTag.Length > maxTargetLength) Then
            Me.targetTag = Me.targetTag.Substring(0, maxTargetLength)
        End If

        tbxTargetTag.Text = targetTag

        Form1.rfid.OperationTime = Form1.ACCESS_TIME_SECONDS
    End Sub
    Private Sub frmKill_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Form1.rfid.OperationTime = Form1.ACCESS_TIME_UNLIMITED
    End Sub


    Public Sub AddString(ByVal str As String)
        listBox1.Items.Add(str)
        listBox1.SelectedIndex = listBox1.Items.Count - 1
    End Sub


    Private Sub btnKill_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnKill.Click
        Dim killPassword As String = Nothing
        Dim maskParam As RFIDMASKPARAMS = New RFIDMASKPARAMS()

        If (String.IsNullOrEmpty(tbxKillPassword.Text) = False) Then
            If (tbxKillPassword.Text.Length <> 8) Then
                MessageBox.Show("Kill password is 4 bytes")
                tbxKillPassword.Focus()
                tbxKillPassword.SelectAll()
                Return

            End If
        End If

        killPassword = tbxKillPassword.Text.Trim()

        If (String.IsNullOrEmpty(tbxKillPassword.Text) = False) Then
            maskParam.MemBank = MEM_BANK.EPC
            maskParam.nOffSet = 4
            maskParam.MaskPattern = tbxTargetTag.Text.Trim()
        End If

        btnKill.Enabled = False
        Cursor.Current = Cursors.WaitCursor

        result = Form1.rfid.KillTag(True, killPassword, False, maskParam)

        Cursor.Current = Cursors.Default
        btnKill.Enabled = True

        AddString(result.ToString())

        If (result = RFID_RESULT.RFID_RESULT_SUCCESS) Then
            Utils.PlaySound("\Windows\Success.wav")
        Else
            Utils.PlaySound("\Windows\Fail.wav")

        End If

    End Sub
End Class